; *** FX Ver 1.0 ***
;
; This is the TI82 version of the zshell program called
; fx, written by Tim FitzRandolph. The code was "ported"
; to the TI82 by Dines Justesen.
;
; All graphics rutines are placed in graph.inc and graph.h
; written by Dines Justesen.
;
; (c) 1997

#INCLUDE "ti82.h"
#INCLUDE "graph.h"

;-----------------
; DATA IN TEXT MEM
;-----------------
xl      = TEXT_MEM
yl      = TEXT_MEM+1

.ORG START_ADDR
.DB "FX Screen Reverser",0
;--------
; PROGRAM
;--------
Init:
        GRAPH_START
Drawtext:
        LD HL,$0A1A
        LD ($8215),HL
        LD HL,Text1
        ROM_CALL(D_ZM_STR)

        LD HL,$1A1A
        LD ($8215),HL
        LD HL,Text2
        ROM_CALL(D_ZM_STR)

        LD HL,$2A1A
        LD ($8215),HL
        LD HL,Text3
        ROM_CALL(D_ZM_STR)

Yloop:
        CALL Xloop
        LD A,0
        LD (xl),A

        LD A,(yl)
        INC A
        LD (yl),a

        LD A,(yl)
        CP 64
        JR Z,Done
        JR Yloop

Xloop:
        LD A,(xl)
        LD B,A
        LD A,(yl)
        LD C,A

        CALL GetPixel
        OR 0
        JR Z,DrawPixel
        JR ErasePixel

DoneDrawing:
        LD A,(xl)
        INC A
        LD (xl),A

        LD A,(xl)
        CP 96
        JR NZ,Xloop
        RET
Ending:
        RET

DrawPixel:
        CALL Point_on
        JR DoneDrawing

ErasePixel:
        CALL Point_off
        JR DoneDrawing

Done:
        CALL GET_KEY
        CP $9
        JR Z,Ending
        CP $37
        JR Z,Ending
        JR Done

#INCLUDE "graph.inc"

Text1:  .db "Screen Reverser",0
Text2:  .db "Tim FitzRandolph",0
Text3:  .db "Dines Justesen",0

.END


